#ifndef DEFINES_H
#define DEFINES_H

#define FALSE 0
#define TRUE  !FALSE



/**
 * Typendefinition fuer vorzeichenfreie 8Bit Integer-Werte
 *
 * Zusatzdefinition als BYTE um gewohnheiten zu entsprechen
 **/
typedef unsigned char BYTE;
enum {MAX_BYTE = 0xFF};

/**
 * Typendefinition fuer vorzeichenfreie 8Bit Integer-Werte
 **/
typedef BYTE UINT8;
enum {MAX_UINT8 = MAX_BYTE};

/**
 * Typendefinition fuer vorzeichenfreie 16Bit Integer-Werte
 **/
typedef unsigned int UINT16;
enum {MAX_UINT16 = 0xFFFF};

/**
 * Typendefinition fuer vorzeichenfreie 16Bit Integer-Werte
 *
 * Zusatzdefinition als WORD um gewohnheiten zu entsprechen
 **/
typedef UINT16 WORD;
enum {MAX_WORD = MAX_UINT16};

/**
 * Typendefinition fuer vorzeichenfreie 32Bit Integer-Werte
 **/
typedef unsigned int UINT32;
enum {MAX_UINT32 = 0x7FFFFFFF};

/**
 * Typendefinition fuer vorzeichenfreie Integer-Werte mit maximaler Bitlaenge
 **/
typedef UINT32 UINTMAX;
enum {MAX_UINTMAX = MAX_UINT32};



#endif
