#include "compress/libs/charCount.h"

UINT16 charCount(BYTE charToCount, UINTMAX charCounter[256])
{
	charCounter[charToCount]++;
	if(charCounter[charToCount] > (MAX_UINTMAX - 2))
	{
		for(UINT16 i = 0; i < 256; i++)
		{
			if(charCounter[i] > 1)
			{
				charCounter[i] >>= 1;
			}
		}
	}
	return charCounter[charToCount];
}


UINT16 charCountFinish(UINTMAX charCounter[256], BYTE* charIndex)
{
	#ifdef TEXTDEBUG
	fprintf(stderr, "\n\t\tSTART charCountFinish()\n");
	#endif
	UINT16	charIndexCount = 0; 
			
	//fuer alle element im zaehlerfeld
	for(UINT16 i = 0; i < 256; i++)
	{
		#ifdef TEXTDEBUG
		fprintf(stderr, "\t\t\tcharCounter[%d] = :%d:\n",i,charCounter[i]);
		#endif
		if(charCounter[i] != 0)
		{
			//suche position im index
			UINT16 j;
			for(j = 0; (( charCounter[i] < charCounter[charIndex[j]]) && ( j < charIndexCount )); j++);
			
			//fuer alle indexwerte ab de aktuellen indexwert
			charIndexCount++;
			for(UINT16 k = charIndexCount; k > j; k--)
			{
				charIndex[k] = charIndex[k-1];
			}
				
			charIndex[j] = i;
		}
	}
	
	#ifdef TEXTDEBUG
	fprintf(stderr, "\n\t\t\tcharIndexCount(%d)\n",charIndexCount);
	for(UINT16 i = 0; i < charIndexCount; i++)
	{
		fprintf(stderr, "\t\t\tcharIndex[%d] \t= %c-:%d: \t= :%d:\n",i,charIndex[i],charIndex[i],charCounter[charIndex[i]]);
	}
	fprintf(stderr, "\n");
	
	fprintf(stderr, "\n\t\tFINISH charCountFinish()\n");
	#endif
	
	return charIndexCount;
}

